#include <os/Process.h>
#include <ui/App.h>
#include <ui/Button.h>
#include <ui/Container.h>
#include <ui/Image.h>
#include <ui/Layout.h>

Result<int> luna_main(int argc, char** argv)
{
    ui::App app;
    TRY(app.init(argc, argv));

    ui::Rect screen = app.screen_rect();

    ui::Rect bar = ui::Rect { ui::Point { 0, screen.height - 50 }, screen.width, 50 };

    auto window = TRY(ui::Window::create(bar, false));
    app.set_main_window(window);
    window->set_background(ui::GRAY);

    ui::HorizontalLayout layout(ui::AdjustHeight::Yes, ui::AdjustWidth::No);
    window->set_main_widget(layout);

    ui::Button button({ 0, 0, 50, 50 });
    layout.add_widget(button);

    ui::Container container({ 0, 0, 50, 50 }, ui::VerticalAlignment::Center, ui::HorizontalAlignment::Center);
    button.set_widget(container);
    button.set_action([] {
        StringView args[] = { "/usr/bin/gclient" };
        os::Process::spawn("/usr/bin/gclient", Slice<StringView> { args, 1 }, false);
    });

    auto image = TRY(ui::ImageWidget::load("/usr/share/icons/32x32/start-icon.tga"));
    container.set_widget(*image);

    window->draw();

    return app.run();
}
